=== doc/requirements.txt ===
sphinx==7.4.7
sphinx-toolbox==3.8.0
sphinx-rtd-theme==2.0.0
