=== debian/changelog ===
colmap (3.13.0-1) experimental; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Mon, 23 Feb 2026 16:09:26 +0000

colmap (3.12.6-4) experimental; urgency=medium

  * d/control:
    - drop libboost-system-dev from b-d. (Closes: #1127180)
    - add libboost1.90-dev, and a few more to build-depends.
    - update Vcs fields.
  * Bump standards version to 4.7.3.

 -- Alex Myczko <tar@debian.org>  Sat, 21 Feb 2026 19:57:09 +0000
